# Zongor's World Machine

The world machine is a Virtual Machine that is intended to create 3D environments (Worlds) for video games and/or generic 3d modeling jobs

It is inspired by [uxn](https://wiki.xxiivv.com/site/uxn.html), [var'aq](https://web.archive.org/web/20210913164515/https://www.oocities.org/connorbd/varaq/index.html), [TIS-100](https://www.zachtronics.com/tis-100/), [Inferno](https://www.inferno-os.org/), and [Plan9](https://plan9.io/plan9/).

The world machine works as a series of stack based virtual cpu's (vcpu) and ram as a simple hashmap (wram) that each have a single stack which are able to communicate with each other using message passing.

The machine code of this vcpu is a series of stack operations which act on the individal vcpu. each vcpu has the ability to ask the kernel to spawn an additional vcpu or to spawn a child vcpu off of itself which sets up a couple of communication channels automatically.

The authors implementation of ZWM in written in C and uses the [SDL2](https://www.libsdl.org/) library to do drawing, sound, and other things.
